#ifndef CB_GIFINPUTFILESTREAM_H
#define CB_GIFINPUTFILESTREAM_H

#include <fstream>
#include <string>

#include "gifinputstream.h"
#include "databuffer.h"

namespace Colosseum
{

class GifInputFileStream : public GifInputStream
{
private:
  bool end_reached ;
  DataBuffer<UBYTE1> input_buffer ;

  GifInputFileStream (const GifInputFileStream &) ;
  GifInputFileStream &operator=(const GifInputFileStream &) ;
  enum  {DEFAULTSIZE = 1 << 16 } ;

  std::ifstream input_stream ;
public:
  GifInputFileStream (unsigned int buffersize = DEFAULTSIZE) ;
  virtual ~GifInputFileStream () ;
  void open (const std::string &filename) ;
  void close () ;
  InputByteStream::POSITIONTYPE tellg () ;
  void seekg (InputByteStream::POSITIONTYPE position) ;
  virtual void fillBuffer () ;
  virtual bool endReached () ;

  class GifInputStreamError ;
} ;

class GifInputFileStream::GifInputStreamError : public std::exception
{
private:
  std::string message ;
public:
  GifInputStreamError (const std::string &msg) : message (msg) {} ;
  GifInputStreamError (const GifInputStreamError &source) : message (source.message) {} ;
  GifInputStreamError &operator=(const GifInputStreamError &source)
  {
    if (&source != this)
    {
      message = source.message ;
    }
    return *this ;
  }
  virtual const char *what () const throw () { return message.c_str () ; } ;
} ;


}


#endif
