#ifndef CB__GIFINPUTSTREAM
#define CB__GIFINPUTSTREAM

#include <stdexcept>
#include "inputbytestream.h"

namespace Colosseum
{

class GifInputStream : virtual public InputByteStream
{
private:
  unsigned int block_count ;
protected:
public:
  void enterBitMode () ;
  unsigned int nextCode (unsigned int codesize) ;
  unsigned int nextBit () ;
  virtual void exitBitMode () ;
  class  GifStreamError ;
} ;


class GifInputStream::GifStreamError : public std::exception
{
private:
  std::string message ;
public:
  GifStreamError (const std::string &msg) : message (msg) {} ;
  GifStreamError (const GifStreamError &source) : message (source.message) {} ;
  GifStreamError &operator=(const GifStreamError &source)
  {
    if (&source != this)
    {
      message = source.message ;
    }
    return *this ;
  }
  virtual const char *what () const throw () { return message.c_str () ; } ;
} ;


}

#endif